#include "main.h"

 
extern SCAN_STRUCT scanStruct;	


BOOLEAN fSignedOn = FALSE;
BOOLEAN chkKbHit(void);
int doGetch(void);

// find/connect device
BOOLEAN EX_SignOn(USHORT usDevID, double dblRate, BYTE bChan)
{
	BYTE bRetVal = 0;
	BYTE numDevicesTemp = 0;
	double dblRateTemp = dblRate;
	bDBG = 0; iErr = 0;
	bRetVal = sendSignon(hDevice_global, usDevID, bChan, &dblRateTemp, bDBG, &iErr);
	if(!bRetVal) { fSignedOn = FALSE; return FALSE; }
	fSignedOn = TRUE;

	return TRUE;
}


//not tested with linux
BOOLEAN EX_ConnectAllDevices ( BYTE* pbNumDevices, USHORT* pDevList, double* pdblRates )
{
	BYTE bRetValTemp = 0;
	USHORT usDevTemp = pDevList[0];
	BYTE numDevicesTemp = 0;
	double dblRateTemp = pdblRates[0];
	//BYTE initUsbLib(USHORT *usDevIDLocal, BYTE bDBG)
	bRetValTemp = initUsbLib(&usDevTemp, 0);
	if(bRetValTemp)
	{
		*pbNumDevices = 1;
		//NOTE also need to set rate after initial testing of this call, as well as loop for all devices?
		//success so leave the rest unchanged
		fSignedOn = TRUE;
		return TRUE;
	}
	else
	{
		*pbNumDevices = 0;
		pDevList[0] = 0;
		pdblRates[0] = 0.0;
		fSignedOn = FALSE;
		return FALSE;
	}
}

//LOOK HERE 
BOOLEAN EX_ConnectOneDevice(USHORT usDevID, double dblRate, BYTE bChan)
{
	//DO NOT CLEAR hDevice_global HERE! 
	//- clear in python code, either now
	//  after a failed signon, or future if you implement a callback from
	//  libusb to indicate cable disconnect.
	BOOLEAN fRet = FALSE;
	if(hDevice_global)
	{	
		fRet = resetDevFirmware(usDevID);
		if(fRet) 
		{
			if(fAllowPrintf) if(bDBG) printf("firmware reset success\n");	
		}
		else 
		{
			if(fAllowPrintf) if(bDBG) printf("firmware reset failed\n");
		}
	}	

	BYTE bRetVal = 0;
	BYTE numDevicesTemp = 0;
	double dblRateTemp = dblRate;

	//LOOK HERE
	// initUsbLib can be called ONLY once per session, or after a cable-disconnect! This is managed
	//  elsewhere where hDevice_global is set to NULL upon a failed reading of firmware as in:
	//  EX_ConnectOneDevice(...)
	if(!hDevice_global) 
	{ 
		bRetVal = initUsbLib(&usDevID, 0);
		if(!bRetVal) return FALSE;
	} 
	 
	bDBG = 0; iErr = 0;
	bRetVal = sendSignon(hDevice_global, usDevID, bChan, &dblRateTemp, bDBG, &iErr);
	if(!bRetVal) 
	{ 
		fSignedOn = FALSE; 
		return FALSE; 
	}
	fSignedOn = TRUE;

	return TRUE;
}

//need to get a conversion in call to getDigitalInput to get digital input
BOOLEAN EX_SendChan(USHORT usDevID, BYTE bChan, BYTE* pbLastDigin)
{
	bDBG = 0;
	if(!fSignedOn) return FALSE;
	BYTE bLastDigin = 0;
	if(!sendChan(hDevice_global, usDevID, bChan, bDBG, &iErr))
		return FALSE;
	if(!getDigitalInput(hDevice_global, usDevID, &bLastDigin, bDBG, &iErr))
		return FALSE;
	*pbLastDigin = bLastDigin;
	return TRUE;
}

BOOLEAN EX_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
{
	if(!fSignedOn) return FALSE;
	if(!setDAC(hDevice_global, usDevID, bDAC, &dblVoltage, bDBG, &iErr))
		return FALSE;
	return TRUE;
}

BOOLEAN EX_GetOneConversion (USHORT usDevID, double* pdblMilliVolts)
{
	if(!fSignedOn) return FALSE;

	BYTE bLastDigin = 0;
	if(!getConversion(hDevice_global, usDevID, pdblMilliVolts, &bLastDigin, bDBG, &iErr))
		return FALSE;
	return TRUE;
}

BOOLEAN EX_GetCalculatedRate (USHORT usDevID, double* pdblRate)
{
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dblDevRate = *pdblRate;
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dblDevRate);
	*pdblRate = dblDevRate;
	return TRUE;
}

BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut)
{
	if(!fSignedOn) return FALSE;
	bDBG = 0;
	if(!setDigout(hDevice_global, usDevID, bDigOut, bDBG, &iErr))
		return FALSE;
	return TRUE;
}

BOOLEAN EX_GetDigin(USHORT usDevID, BYTE* bDigIn)
{
	if(!fSignedOn) return FALSE;
	bDBG = 0;
	BYTE bDigin_ = *bDigIn;
	if(!getDigitalInput(hDevice_global, usDevID, &bDigin_, bDBG, &iErr))
		return FALSE;
	*bDigIn = bDigin_;
	return TRUE;
}

BOOLEAN EX_SendRate(USHORT usDevID, double* dblRate)
{
	if(!fSignedOn) return FALSE;
	bDBG = 0;
	double dblRate_ = *dblRate;
	if(!sendRate(hDevice_global, usDevID, &dblRate_, bDBG, &iErr))
		return FALSE;
	return TRUE;
}



