//from: http://stackoverflow.com/questions/14769107/libusb-bulk-transfer

#include "main.h"

//8-26-24
#include <sys/ioctl.h>
unsigned char str_tx[8];    //data to send to device  
unsigned char  *dataOut = NULL;

BYTE bUsbLibInitSuccess = 0;
BYTE bInitLibSuccess = FALSE;

int iLenIn = 8; 
int iLenOut = 32;
int iRetCode = 0;
int tRet; 

int interface_ref = 0;
int alt_interface,interface_number; 

pthread_t tid[2];

//shared with a thread so made volatile
//this is the main instance used by other source code files 
volatile SCAN_STRUCT scanStruct; 

pthread_t tid[2];
unsigned long cnt = 0;


BOOLEAN EX_SendDAC_noWait(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
{
	if(!fSignedOn) return FALSE;
	if(!setDAC(hDevice_global, usDevID, bDAC, &dblVoltage, bDBG, &iErr)) return FALSE;
	return TRUE;
}


BOOLEAN sendSignonToken(USHORT usDevID)
{
	unsigned char  *myDataOut = NULL;	
	myDataOut = (unsigned char *)malloc(32);	

	BYTE bDigOutVal = 255;
		
	int i = 0;
	while(1==1) //8-29-24 TEMP	
	{ 
		int ret_rst;
		ret_rst = libusb_reset_device(hDevice_global);
		if(ret_rst < 0) 
		{ 
			if(fAllowPrintf)  printf("Error in reset: %d \n", ret_rst); 
			return FALSE; 
		}

		str_tx[0]=0x0;    			//token
		str_tx[0]=0x0;    			//arg
		str_tx[0]=0x0;    			//checksum

		int len = 8; 
		iRetCode = libusb_bulk_transfer(hDevice_global,0x2,str_tx,8,&iLenIn,8);
		if(iRetCode==0) 
		{ 
			if(fAllowPrintf) printf("library -> signon token-send success\n");
		}
		else
		{
			if(fAllowPrintf) printf("library -> signon token-send failed\n");
			i++;
			if(i==4)
			{
				if(fAllowPrintf) printf("library -> signon token-send returning FALSE\n");
				return FALSE; 
			}
			continue;
		}
		//read signon return codes
		int tempCnt = 0;
		len = 0; 
		sleep(3);	
		BOOLEAN fThisSignonOk = FALSE;
		int loopCnt = 0;
		while(1==1)
		{
			memset(myDataOut,'\0',32);
			sleep(2);	
			iRetCode = libusb_interrupt_transfer(hDevice_global,0x81,myDataOut,32,&len,32);
			if(fAllowPrintf) printf("*#*iRetCode %u, len: %u\n", iRetCode, len);
			if((iRetCode == 0) && (len == 32)) 
			{
				if(fAllowPrintf) printf("#**# got CORRECT call return vals\n");
				//NOTE; vals read may be all zeroes which seems to be okay
				fThisSignonOk = TRUE;
				break;
			}
			else 
			{
				printf("#**# got WRONG signon return vals\n");
				loopCnt++;
				if(loopCnt > 1)
				{
					if(fAllowPrintf) printf("library -> signon token-send returning FALSE\n");
					return FALSE;
				}
				continue;
			}	
		}
		if(fThisSignonOk)
		{	
			if(fAllowPrintf) if(bDBG)
			{
				printf("signon results:\n");
				printf("myDataOut[26]: 0x%x\n", myDataOut[26] & 0xfe);
				printf("myDataOut[27]: 0x%x\n", myDataOut[27]);
				printf("myDataOut[28]: 0x%x\n", myDataOut[28]);
				printf("myDataOut[29]: 0x%x\n", myDataOut[29]);
				printf("myDataOut[30]: 0x%x\n", myDataOut[30]);
				printf("myDataOut[31]: 0x%x\n\n", myDataOut[31]);
				printf("NOTE: may be all zeoes after first signon?\n");
			}
			//for testing only
			/*
			BYTE bDigoutToken = 0x2;
			bDigOutVal = bDigOutVal ^ 255;
			//sleep(1);  //commented because can't sleep if called while scanning
			str_tx[0]=0x2;    //analog out token
			str_tx[1]=bDigOutVal;
			str_tx[2]=bDigoutToken + bDigOutVal;
			int mRetCode = libusb_bulk_transfer(hDevice_global,0x2,str_tx,8,&iLenIn,2000);
			if(mRetCode==0) { printf("*$* send digital output token success.\n\n"); }
			else { printf("*$* setDigout error\n"); }
			*/
		}
		else 
		{  
			if(fAllowPrintf) if(bDBG) printf("sendSignonToken failed \n");
			return FALSE;
		}
		sleep(.25);
	} 
}


//8-26-24 - next two functions added
BOOLEAN resetDevFirmware(USHORT usDevID)
{
	str_tx[0]=1;    //firmware reset vector
	str_tx[1]=0;
	str_tx[2]=1;
	
	//if(fAllowPrintf) printf("attempting reset for: %i", usDevID);
	iRetCode = libusb_bulk_transfer(hDevice_global,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		//8-29-24b
		sleep(2);		
		
		if(fAllowPrintf)if(bDBG) printf("device firmware reset success for device: %i", usDevID);
		return TRUE;
	}
	if(fAllowPrintf)if(bDBG) printf("device firmware reset failed for device: %i", usDevID);
	return FALSE;
}

//8-27-24 clearDevHandle
//8-27-24 BOOLEAN resetDevLinuxHub(USHORT usDevID)
BOOLEAN clearDevHandle(USHORT usDevID)
{
	hDevice_global = NULL; //8-27-24B
	return TRUE; //8-27-24B
	
	
	int rc = 0;
	//if(fAllowPrintf) printf("attempting reset of hub for: %i", usDevID);
	rc = libusb_reset_device(hDevice_global);
	if (rc==0) 
	{
			//if(fAllowPrintf) printf("hub reset success for device: %i", usDevID);
			return TRUE;
	}
	//else
		//if(fAllowPrintf) printf("hub reset failed for device: %i", usDevID);
	return FALSE;
}


BOOLEAN testVal (USHORT val )
{
	printf("\ngot newVal: %x\n", scanStruct.uiScanToken);
	printf("\ngot newVal: %x\n", val);
}


BOOLEAN AllowPrintf(BOOLEAN fDoAllowPrintf)
{
	fAllowPrintf = fDoAllowPrintf;
}

//####################################################
//## scanReadCallback ################################
//####################################################
//function called whenever call to low-level driver
//  returns with/without data
void scanReadCallback(struct libusb_transfer *transfer)
{
	// called whenever a read is completed	
	int *completed = transfer->user_data;
	*completed = 1;
}


//#####################
//## DOSCAN ###########
//#####################
//scan thread that reads data from driver
//from: http://stackoverflow.com/questions/3508507/what-are-gcc-on-linuxs-equivalent-to-microsofts-critical-sections
volatile BYTE bCurrentCall = 0;
//following is pretty "safe" for various scan configurations. If a "buffer wrap" occurs, increase to queue more.
#define MAX_QUEUE 10  

typedef struct _SCAN_READ_CALLBACK_STRUCT
{
	int scanReadCompleted[MAX_QUEUE];
	unsigned char* dataOutScan[MAX_QUEUE];
	struct libusb_transfer* transferGrp[MAX_QUEUE];
	int scanDataStart[MAX_QUEUE];
	BOOLEAN fActiveCall[MAX_QUEUE];
} SCAN_READ_CALLBACK_STRUCT, *PSCAN_READ_CALLBACK_STRUCT;
SCAN_READ_CALLBACK_STRUCT scan_read_callback_struct;
struct libusb_transfer *transfer;  

//for testing
int digOutTemp = 0;
double analogOutTemp = 0;
//BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut)
//EX_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
//setDAC(hDevice_global, usDevID, bDAC, &dblVoltage, bDBG, &iErr))

void* doScan(void *arg)
{
//fAllowPrintf = TRUE;
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("entering scan thread \n");

	scanStruct.uiPointsInBuff = 0;

//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("scanStruct.uiStackedScans: %d\n", scanStruct.uiStackedScans); 
	unsigned char bMicroBuffWrap = 0;
	unsigned char bLocalBuffWrap = 0;
	int numTransfers = scanStruct.uiStackedScans;
	int offsetMultiplier = ((numTransfers - 1) * 32);

	int* returnVal;
	int len=64,ret_alt,ret_clm,ret_rst;


	unsigned char str_tx[8];   	//data to send to device
	unsigned char str_rx[32];		//receive string
	unsigned char numChans = 1;

	//not set even if calscan - channel handling elsewhere
	BYTE isCalScan = 0;

	str_tx[0]=scanStruct.uiScanToken;								//scan token
	str_tx[1]=scanStruct.uiScanChans + isCalScan;		//chan count
	str_tx[2]=scanStruct.uiScanToken + scanStruct.uiScanChans + isCalScan; //checksum
	BOOLEAN fIsDigScan = FALSE;
	if((scanStruct.uiScanToken == CMND_SINGLE_CHAN_DIGIN_SCAN)
			|| (scanStruct.uiScanToken == CMND_MULTI_CHAN_DIGIN_SCAN)
			|| (scanStruct.uiScanToken == CMND_MULTI_CHAN_CAL_DIGIN_SCAN))
		fIsDigScan = TRUE;
	//BYTE bScanPacketByteCnt = 3;
	//if(fIsDigScan) bScanPacketByteCnt = 4;
	
	//LOOK HERE - this is for the hard-coded channel count - should adjust with user input elsewhere
	//bScanPacketByteCnt = 9; //3chans * 3
	
	//9-16-24 MOVED TO HERE
	fPossibleScanPower_Err = FALSE;
	fPossibleScanUSB_Err = FALSE;

	iRetCode = libusb_bulk_transfer(hDevice_global, 0x2, str_tx, 8, &iLenIn, 2000);
	unsigned int timeStart = (unsigned)time(NULL);

	if(iRetCode==-1) 
		if(fAllowPrintf) printf("Error in io\n");

	if(iRetCode==0)
	{
		//printf("single-channel scan token token success.\n\n");
	}
	else
	{
		if(fAllowPrintf) printf("Error in bulk transfer \n");

		*returnVal = -1;
		scanStruct.fScanThreadLoopDone = TRUE;
		scanStruct.isScanning = 0;
		scanStruct.inThread = 0;
		return returnVal;  
	}


	char buff[32];

	int iRawCnt;
	double dblVolts;

	struct libusb_transfer *transfer;
	scanStruct.isScanning = 1;

	BYTE scanTemp[25];
	BYTE scanTempPntr = 0;
	BYTE bTempScanCntTrack = 0;

	BYTE bStackedTransferRemainingOffset = 0;

	double cpu_time_used;

	transfer = libusb_alloc_transfer(0);

	BYTE bArrayIndex = 0;

	//queue all - this queues as many requests as per MAX-QUEUE so while the results for one is being
	// processed (displayed on screen and/or logged to file) another is being processed by libusb
	//This is necessary since the firmware buffer size is limited and in order to prevent it from overflow
	// the USB driver needs to be constantly emptying it. The processing of data within this "user level" 
	// thread, even if optimized in every way, it along with other interruptions from other applications
	// or background processes can prevent usblib from keeping up with emptying of the firmware buffer.

	for(bArrayIndex = 0; bArrayIndex < MAX_QUEUE; bArrayIndex++)
	{
		scan_read_callback_struct.scanReadCompleted[bArrayIndex] = 0;

		scan_read_callback_struct.dataOutScan[bArrayIndex] = (BYTE *)malloc(32 * numTransfers);
		memset(scan_read_callback_struct.dataOutScan[bArrayIndex],'\0',32);
		scan_read_callback_struct.transferGrp[bArrayIndex] = libusb_alloc_transfer(0);
		libusb_fill_bulk_transfer(scan_read_callback_struct.transferGrp[bArrayIndex], hDevice_global, 0x81, 
			scan_read_callback_struct.dataOutScan[bArrayIndex], 32 * numTransfers,
			scanReadCallback, &scan_read_callback_struct.scanReadCompleted[bArrayIndex], 8000);
		libusb_submit_transfer(scan_read_callback_struct.transferGrp[bArrayIndex]);
		scan_read_callback_struct.scanDataStart[bArrayIndex] = clock();
		scan_read_callback_struct.fActiveCall[bArrayIndex] = TRUE;
	}
	bCurrentCall = 0;
	clock_t scanDataEnd;
	
	//LOOK HERE
	BOOLEAN fBreakDataLoop = FALSE; //set if there is a scan data error, so other errors can  
																	// be recorded befor breaking out of main data-take loop
	BYTE bDiginByteCnt = 0;					//byte index into calling app digin array
	BYTE uiByteIndex = 0;						//byte index into returned scan packet
	BYTE bChanByteCnt = (scanStruct.uiScanChans + isCalScan) * 3;				//total byte count per packet	 for non-digin scan
	if(fIsDigScan) bDiginByteCnt = scanStruct.uiScanChans + isCalScan;  //if digin scan, one more byte per data point
	BYTE bTotalByteCnt = bChanByteCnt + bDiginByteCnt;									//total byte count

	fScanThreadWait = TRUE; 
	while(1==1)
	{
		int seconds = 1;
		int minutes = 1;
		int hours = 1;

		libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bCurrentCall]);
		while(scan_read_callback_struct.scanReadCompleted[bCurrentCall] == 0)
		{
			libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bCurrentCall]);
			//will also need to do key-press check here.
			//requeue this one at end of gettting data - increment bCurrentCall and set fActiveCall to FALSE
		}
		transfer = scan_read_callback_struct.transferGrp[bCurrentCall];

		//code to detect possible disconnect - time for transfer return greatly increased during power loss or disconnect
		scanDataEnd = clock();
		cpu_time_used = ((double) (scanDataEnd - scan_read_callback_struct.scanDataStart[bCurrentCall])) / CLOCKS_PER_SEC;

		//allow 4x actual data rate. The "10" below is because there are 10 scans in each returned 32-byte transfer
		//may want to optimize this a bit to deal with really slow scan rates.
		if( (cpu_time_used) >  (((1 / dblDataRate) * 4) * 10 * numTransfers)  )   
		{ fPossibleScanPower_Err = TRUE; }

		switch(transfer->status)
		{
			case LIBUSB_TRANSFER_COMPLETED:
				//no need to handle no error
				//printf("case: LIBUSB_TRANSFER_COMPLETED\n");
				break;
			case LIBUSB_TRANSFER_CANCELLED:
				//printf("case: 2\n");
			case LIBUSB_TRANSFER_NO_DEVICE:
				//printf("case: 3\n");
			case LIBUSB_TRANSFER_TIMED_OUT:
				//printf("case: 4\n");
			case LIBUSB_TRANSFER_ERROR:
				//printf("case: 5\n");
			case LIBUSB_TRANSFER_STALL:
				//printf("case: 6\n"); 
			case LIBUSB_TRANSFER_OVERFLOW:
				// Various type of errors here

				fUSB_ERROR = TRUE;  
				break;
		}

		if(fPossibleScanPower_Err)
		{
			fUSB_ERROR = TRUE;
			if(fAllowPrintf) { printf("\n\nscan data timeout\n"); printf("packet read-time taken: %lf,  packet max read-time needed: %lf \n", cpu_time_used, (((1 / dblDataRate) * 4) * 10)); }
		}
		else if(fUSB_ERROR)
		{
			fPossibleScanUSB_Err = TRUE;
			if(fAllowPrintf) { printf("\n\nscan data timeout\n"); printf("device seems to have been disconnected\n"); }
			
			fContScanDone = TRUE; 
			*returnVal = -1;
			scanStruct.fScanThreadLoopDone = TRUE;
			scanStruct.isScanning = 0;
			scanStruct.inThread = 0;
			fBadScanEnd = TRUE; 
			fPossibleScanUSB_Err = TRUE;;
			return returnVal;  
		}

		int iOffset = 0;
		//this outer FOR loop prints ALL the data. Without it, only the last 10 scans
		//   of each "stacked" packet are printed.
		unsigned char bIndex;
 
		BYTE bDoBreak = 0;
		UINT st = scanStruct.uiScanToken;  
		
		BYTE bIsDigin = 0;
		if(fIsDigScan) bIsDigin = 1;

		for(bIndex = 0; bIndex < numTransfers; bIndex++)
		{
			int iOffset = 0;
			offsetMultiplier = (bIndex * 32);

			for(iOffset = (offsetMultiplier) + 30; iOffset > (offsetMultiplier); iOffset--)  //5-10-17
			{
				if(fUSB_ERROR) { scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; break; }

				scanTemp[scanTempPntr] = transfer->buffer[iOffset];
				scanTempPntr++;

				//LOOK HERE: NOTE each channel has 3 bytes and the last channel is the calibration
				// channel (usually around 0 volts). If a digital-input scan, each channel, if a 
				// digital-input scan, is followed by a digital input.				
				//7-25-24 changed to actual channel count instead of 2-chan cal scan and byte cnt
				// to include digital input bytes if digital input scan
				BYTE uiByteIndex = 0;
				fBreakDataLoop = FALSE;

				if(scanTempPntr >= (bChanByteCnt + bDiginByteCnt))	
				{
					scanTempPntr = 0;
					fBreakDataLoop = FALSE;
					//LOOK HERE
					while(uiByteIndex < bTotalByteCnt)
					{
					
						iRawCnt = scanTemp[uiByteIndex + 2] + (scanTemp[uiByteIndex + 1] * 256) + (scanTemp[uiByteIndex] * 65536);
						scanStruct.scanBuff[scanStruct.uiHeadPntr] = iRawCnt;
						
						if(fIsDigScan)
						{	
							scanStruct.diginBuff[scanStruct.uiHeadPntr] = (scanTemp[uiByteIndex + 3]) & 0xf;
							uiByteIndex++; 
						}
						uiByteIndex+=3;
						(scanStruct.uiHeadPntr) = (scanStruct.uiHeadPntr) + 1; 
						if(scanStruct.uiHeadPntr == scanStruct.uiBufferSizeMax) scanStruct.uiHeadPntr = 0;
						scanStruct.uiPointsInBuff = scanStruct.uiPointsInBuff + 1;				
						if(scanStruct.uiPointsInBuff > scanStruct.uiBufferSizeMax)
						{
							scanStruct.fGotBuffWrap = 1;
							bLocalBuffWrap = 1;
							if(fAllowPrintf)  { printf("\n got LOCAL buffer wrap!\n"); printf("scans in buff: %d, max: %d", scanStruct.uiPointsInBuff, scanStruct.uiBufferSizeMax); }
							scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
							fBreakDataLoop = TRUE;
							bDoBreak = 1;
						}
					}
					
					if((transfer->buffer[31] & 1) != 0) 
					{
						bMicroBuffWrap = TRUE;
						fBreakDataLoop = TRUE;
					}
					if(fContScanDone) 
					{ 
						scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
						fBreakDataLoop = TRUE;
					}

					if((!fContinuousScan) && (fTimedScan == TRUE))
					{
						if(fScanSeconds)
						{
							if( (((unsigned)time(NULL)) - timeStart) >= uiScanSeconds)
							{ 
								scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
								break; 
							}
						}
						else if(fScanMinutes)
						{
							if( ((((unsigned)time(NULL)) - timeStart) / 60 ) >= uiScanMinutes)
							{ 
								scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
								break; 
							}
						}
						else if(fScanHours)
						{
							if( ((((unsigned)time(NULL)) - timeStart) / 360 ) >= uiScanHours)
							{ 
								scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
								break; 
							}
						}
					
					}
					
				}
				if(fBreakDataLoop) break;
			}
			if(fBreakDataLoop) break;
			if(bMicroBuffWrap) break;
			if(bLocalBuffWrap) break;
			if(bDoBreak) break; 
		}

		if(bMicroBuffWrap) 
		{
			if(fAllowPrintf) { printf("\ngot MICRO-CODE buffer wrap!\n"); printf("may need to increase stacked requests"); }
			break;
		}
		if(bLocalBuffWrap)
		{
			if(fAllowPrintf) { printf("\ngot LOCAL buffer wrap!\n"); printf("may need to increase local buffer size"); }
			break;
		}

		if(bDoBreak) break;
		if(fBreakDataLoop) break;

		//re-queue the one just finished
		scan_read_callback_struct.fActiveCall[bCurrentCall] = FALSE;
		scan_read_callback_struct.scanReadCompleted[bCurrentCall] = 0;
		memset(scan_read_callback_struct.dataOutScan[bCurrentCall],'\0',32);
		scan_read_callback_struct.transferGrp[bCurrentCall] = libusb_alloc_transfer(0);
		libusb_fill_bulk_transfer(scan_read_callback_struct.transferGrp[bCurrentCall], hDevice_global, 0x81, 
			scan_read_callback_struct.dataOutScan[bCurrentCall], 32 * numTransfers,
			scanReadCallback, &scan_read_callback_struct.scanReadCompleted[bCurrentCall], 8000);
		libusb_submit_transfer(scan_read_callback_struct.transferGrp[bCurrentCall]);
		scan_read_callback_struct.scanDataStart[bCurrentCall] = clock();
		scan_read_callback_struct.fActiveCall[bCurrentCall] = TRUE;

		bCurrentCall++;
		if(bCurrentCall == MAX_QUEUE) bCurrentCall = 0;
	}
	scanStruct.fScanThreadLoopDone = TRUE;
	unsigned int timeTotal = ((unsigned)time(NULL)) - timeStart;

	if(!fPossibleScanPower_Err)
		for(bArrayIndex = (MAX_QUEUE - 1); bArrayIndex > 0; bArrayIndex--)
		{
			if(scan_read_callback_struct.fActiveCall[bArrayIndex] == TRUE)
			{
				libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bArrayIndex]);
				while(scan_read_callback_struct.scanReadCompleted[bArrayIndex] == 0)
					libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bArrayIndex]);
			}
		}
  if(fAllowPrintf) if(bDBG)printf("sending end-scan codes\n");


	str_tx[0]=0x8a;		//end scan token
	str_tx[1]=0x0;		//no argument token
	str_tx[2]=0x8a;		//checksum
	iRetCode = libusb_bulk_transfer(hDevice_global,0x2,str_tx,8,&iLenIn,2000);

	fGotCorrectEndScanCodes = FALSE;
 
	unsigned char dataOut[32];	//receive string
	memset(dataOut,'\0',32);
	int iLenOut = 32;
	UINT bLoopCnt = 0;
	
	//LOOK HERE
	if(!fPossibleScanUSB_Err) 
	{
		if(fAllowPrintf) printf("from library -> starting wait for end-scan codes echo\n");
		if(fAllowPrintf) printf("from library -> should be: 0, 23, 3, 2, 1\n");
	}

	libusb_cancel_transfer(transfer);

	//LOOK HERE
	if(!fPossibleScanUSB_Err) //8-27-24d
	{
		while(TRUE)
		{
			iRetCode = libusb_interrupt_transfer(hDevice_global,0x81,dataOut,32,&iLenOut,3000);
			if(iRetCode!=0) 
			{ 
				break; 
			}
			usleep(100);
			
			if((dataOut[28] == 0) && (dataOut[27] == 0x23) && (dataOut[26] == 3) && (dataOut[25] == 2) && (dataOut[24] == 1))
			{
				memset(aEndScanCodes, 0, sizeof(aEndScanCodes));
				paEndScanCodes = aEndScanCodes;

				for(int i = 28; i > 23; i--)
				{
					paEndScanCodes[28-i] = dataOut[i];
				}
				
				fGotCorrectEndScanCodes = TRUE;
				if(fAllowPrintf) printf("from library -> end-scan codes: %x, %x, %x, %x, %x\n", dataOut[28], dataOut[27], dataOut[26], dataOut[25], dataOut[24]);
				break;
			}
		}
	}	
	if(!fGotCorrectEndScanCodes) 
		if(fAllowPrintf) printf("from library -> incorrect end of scan codes (perhaps due to firmware or thread buffer wrap)");

	fEndScanTokenSent = TRUE;
	fScanThreadWait = FALSE;
}


//#################################
//## checkConnectLLabs ############
//#################################
//ADDED 8-21-24 to check connect at  
//    anytime except while scanning
//#################################
BOOLEAN checkConnectLLabs(USHORT usDevIDLocal, BOOLEAN* fFndLLabs, BOOLEAN* fFndDev)
{
	struct libusb_device *dev,*dev_expected;
	struct libusb_device_descriptor desc;
	BOOLEAN fDone = FALSE;
	*fFndLLabs = FALSE;
	*fFndDev = FALSE;
	
	iRetCode = libusb_init(NULL);
	int i = 0;
	if(iRetCode < 0)
	{ 
		if(fAllowPrintf) 
			printf("\nfailed to initialise libusb\n"); 
		return FALSE; 
	}
	cnt = libusb_get_device_list(NULL, &devs);
	if (cnt < 0)
	{
		if(fAllowPrintf) 
			printf("\nthere are no USB devices on bus\n");
		return FALSE;
	}
	while ((dev = devs[i++]) != NULL)
	{
		iRetCode = libusb_get_device_descriptor(dev, &desc);
		if (iRetCode < 0)
		{
			if(fAllowPrintf) if(bDBG) 
				printf("failed to get device descriptor\n");
			libusb_free_device_list(devs,1);
			break;
		}
		if(desc.idVendor != 0x724) 
		{
			continue; 
		}
		else
		{
			if(fAllowPrintf) 
				printf("\n*** got idVendor: 0x724\n");
				*fFndLLabs = TRUE;
			if(usDevIDLocal == desc.bcdDevice)
				*fFndDev = TRUE;
			return TRUE;
		}
	}
	return FALSE;
}

//##############################################
//## initUsbLib ################################
//##############################################
BOOLEAN fDone = FALSE;
BYTE initUsbLib(USHORT *usDevIDLocal, BYTE bDBG)
{

	struct libusb_device_handle *handle = NULL, *hDevice_expected = NULL;
	struct libusb_device *dev,*dev_expected;

	struct libusb_device_descriptor desc;
	struct libusb_endpoint_descriptor *epdesc;
	struct libusb_interface_descriptor *intdesc;

	ssize_t cnt;
	int e = 0,config2;
	int i = 0,index;

	char str1[64], str2[64];
	char found = 0;

	// Init libusb
	iRetCode = libusb_init(NULL);
	if(iRetCode < 0)
	{ 
		if(fAllowPrintf) if(bDBG) printf("\nfailed to initialise libusb\n"); 
		return 0; 
	}

	cnt = libusb_get_device_list(NULL, &devs);
	if (cnt < 0)
	{
		if(fAllowPrintf) if(bDBG) printf("\nThere are no USB devices on bus\n");
		return 0;
	}
	BOOLEAN fSuccessInit = FALSE;
	while ((dev = devs[i++]) != NULL)
	{
		iRetCode = libusb_get_device_descriptor(dev, &desc);
		if (iRetCode < 0)
		{
			if(fAllowPrintf) if(bDBG) printf("failed to get device descriptor\n");
			libusb_free_device_list(devs,1);
			libusb_close(handle);
			break;
		}
		
		if(desc.idVendor != 0x724) 
		{
			continue; 
		}
		
		if(hDevice_global != NULL) // "should" always be NULL as of 8-27-24
		{
			if(fAllowPrintf) if(bDBG) printf("\n**hDevice_global != NULL\n"); 
			libusb_close(hDevice_global);
			libusb_exit (NULL);		
			iRetCode = libusb_init(NULL);
			if(iRetCode < 0)
			{ 
				if(fAllowPrintf) if(bDBG) printf("\n**failed to initialise libusb after uninit\n"); 
				return 0; 
			}
			if(fAllowPrintf) if(bDBG) printf("\n**success reinitialising libusb after uninit\n");
			if((dev = devs[i]) == NULL)
			{
				if(fAllowPrintf) if(bDBG) printf("\n**dev = devs[%u]) == NULL\n", i);
				if(fAllowPrintf) if(bDBG) printf("\n**returning false\n");
				return 0; 
			} 
			if(desc.idVendor != 0x724) 
			{
				return 0; 
			}
			else if(fAllowPrintf) if(bDBG) printf("\n*** got idVendor: 0x724\n");
			
		}
		else if(fAllowPrintf) if(bDBG) printf("\n**hDevice_global == NULL\n");
		
			if(fAllowPrintf) if(bDBG) printf("\n*** got idVendor: 0x724\n");
			fDone	= TRUE;

		e = libusb_open(dev,&handle);
		if (e < 0)
		{
			if(fAllowPrintf) if(bDBG) printf("error opening device\n");
			libusb_free_device_list(devs,1);
			libusb_close(handle);
			break;
		}

		if(*usDevIDLocal == desc.bcdDevice)
			fSuccessInit = TRUE;

		if(fAllowPrintf) if(bDBG) 
		{
			printf("\nDevice Descriptors: ");    
			printf("\n\tVendor ID : %x",desc.idVendor);    
			printf("\n\tProduct ID : %x",desc.idProduct);    
			printf("\n\tSerial Number : %x",desc.iSerialNumber);    
			printf("\n\tSize of Device Descriptor : %d",desc.bLength);    
			printf("\n\tType of Descriptor : %d",desc.bDescriptorType);    
			printf("\n\tUSB Specification Release Number : %d",desc.bcdUSB);    
			printf("\n\tDevice Release Number : %d",desc.bcdDevice);    
			printf("\n\tDevice Class : %d",desc.bDeviceClass);    
			printf("\n\tDevice Sub-Class : %d",desc.bDeviceSubClass);    
			printf("\n\tDevice Protocol : %d",desc.bDeviceProtocol);    
			printf("\n\tMax. Packet Size : %d",desc.bMaxPacketSize0);    
			printf("\n\tNo. of Configuraions : %d\n",desc.bNumConfigurations); 
		}

		hDevice_global = handle;
		if(fSuccessInit) 
		{
			if(fAllowPrintf) if(bDBG) printf("successfully connected to: %u\n", desc.bcdDevice); 
			return 1;
		}
		return 0;  //will need to change this to check more devices - currently just first found

		if(fDone) return 1;
	}
	return 0;
}


#define NO_CONNECT_ERROR 0
#define PWR_CONNECT_ERR 1
#define USB_CONNECT_ERR 2
#define UNKNOWN_CONNECT_ERR 3

BOOLEAN checkDevConnect(libusb_device_handle *dev_handle, UINT* uiErrType)
{
	BYTE bDoNothingToken = 0x6;
	str_tx[0]=bDoNothingToken;    //analog out token
	str_tx[1]=0;
	str_tx[2]=bDoNothingToken;
	iRetCode = libusb_bulk_transfer(dev_handle,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		//if(bDBG)printf("send digital output token success.\n\n");
	}
	else 
	{  
		*uiErrType = USB_CONNECT_ERR;
		return 0; 
	}
	int len=8;  
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(dev_handle,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==-1) 
	{
//		if(bDBG) printf("transfer return code: %d in io\n", iRetCode);
	}
	if(iRetCode==0)
	{
//		if(bDBG) printf("send get-conv token success.\n\n");
	}
	else 
	{  
		*uiErrType = UNKNOWN_CONNECT_ERR;
		return 0; 
	}

	//read getconversion
	memset(dataOut,'\0',32);
	len = 32; //3-13-17
	iRetCode = libusb_interrupt_transfer(dev_handle,0x81,dataOut,32,&iLenOut,5000);
	//    printf("Error number :: %d\n",iRetCode);
	//if(iRetCode==-1) printf("Error in io\n");

	if(iRetCode!=0)
	{
		*uiErrType = USB_CONNECT_ERR;
		return 0; 
	}
	else if(iRetCode==0)
	{
		if(dataOut[26] == 0xff)
		{
			*uiErrType = PWR_CONNECT_ERR;
			return 0;
		}
		return 1;
	}
	*uiErrType = UNKNOWN_CONNECT_ERR;
	return 0;
}


DOUBLE dblActualRate;
//#########################################################################################
//## CALCRATECODES ########################################################################
//#########################################################################################
BYTE calcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dblDevRate)
{
	//NOTE: following taken from our common Windows DLLs
	DOUBLE dblRateTemp = *dblDevRate;

	BYTE bModeFlagBit = 128;

	//constant for rate calculation. Is crystal frequency /512
	UINT lKVal = 9830400 / 512;
	BYTE bTypeMode = 16;
	double dbIntervalTemp = 1.0 / dblRateTemp;
	SHORT sRateCount = (SHORT)((lKVal * bTypeMode * dbIntervalTemp + 0.5) - 1);
	USHORT sRateCmndLow = sRateCount & 0xff;

	*bLow = (BYTE)sRateCmndLow;
	USHORT sRateCmdMid = bModeFlagBit | ((sRateCount & 0x1f00) / 256);
	*bMid = (BYTE)sRateCmdMid;
	*bHigh = 0;

	double dblActualInterval = (double)((((sRateCmdMid & 0x1f) * 256) + sRateCmndLow) + 1) / (lKVal * bTypeMode);
	dblActualRate = 1.0 / dblActualInterval;

    double dbl1 = (dblRateTemp - dblActualRate) * 1000000000000.0;
    double dbl2 = (dblActualRate - dblRateTemp)  * 1000000000000.0;

    if (dbl1 > 0)
    {
		//difference between requested rate and actual rate
    }

    if (dblActualRate == dblRateTemp)
    {
		//calculated rate same as requested rate
    }


    if ( (dblActualRate != dblRateTemp) &&
            ( (dblActualRate - dblRateTemp > .000001) ||  (dblRateTemp - dblActualRate > .000001)))
    {
		//rate adjustment value
    }
    else dblActualRate = dblRateTemp;

    *dblDevRate = dblActualRate;
    return TRUE;
}


//#########################################################################################################
//#########################################################################################################
//#########################################################################################################
//## sendRate #############################################################################################
//#########################################################################################################
BYTE sendRate(struct libusb_device_handle *hDevice, USHORT usDevID, double* dblRate_, BYTE bDBG, int* iErr)
{
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dblDevRate = *dblRate_;
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dblDevRate);
	if(fAllowPrintf) if(bDBG)printf("got bLow: %d, bMid: %d, bHigh: %d\n", bLow_, bMid_, bHigh_);

	//send rate
	if(fAllowPrintf) 
	{
		if(dblDevRate != *dblRate_)if(bDBG)printf("sending rate (requested was: %lf, adjusted: %lf\n", *dblRate_, dblDevRate);
		else if(bDBG)printf("sending rate %lf\n", dblDevRate);
	}
	dblDevActualRate = dblDevRate; //6-6-17
	
	sleep(2);
	int bLow = bLow, bMid = 129, bHigh = 0;	

	bLow = bLow_;
	bMid = bMid_;
	bHigh = bHigh_;

	str_tx[0]=0x84;	//rate token
	str_tx[1]=bLow; 	
	str_tx[2]=bMid; 	
	str_tx[3]=bHigh;	
	str_tx[4]=0x22;	
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
		if(fAllowPrintf) printf("**rate send success.\n"); 
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG)printf("Error %d sending rate \n", iRetCode);
		*iErr = iRetCode;
		if(fAllowPrintf) if(bDBG)printf("exiting sendRate - FAILED\n");		
		return FALSE; 
	}

	//read rate result
	int iSuccess = 0;
	int tempCnt = 0;
	while(1==1)
	{
   sleep(.25);
    //iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,1000);
    iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,4000);
		if((dataOut[24] == 0x1) && (dataOut[25] == 0x2) && (dataOut[26] == 0x3)
		&& ((dataOut[27] & 0xfe) == 0x22) && (dataOut[28] == bHigh) && (dataOut[29] == bMid)
		&& (dataOut[30] == bLow))
		{
			if(fAllowPrintf) 
			{
						printf("got correct syscal return vals\n");
						printf("dataOut[24]: 0x%x\n", dataOut[24]);
						printf("dataOut[25]: 0x%x\n", dataOut[25]);
						printf("dataOut[26]: 0x%x\n", dataOut[26]);
						printf("dataOut[27]: 0x%x\n", dataOut[27] & 0xfe);
						printf("dataOut[28]: 0x%x\n", dataOut[28]);
						printf("dataOut[29]: 0x%x\n", dataOut[29]);
						printf("dataOut[30]: 0x%x\n", dataOut[30]);
						printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
			}
			iSuccess = 1;
			break;
		}
		tempCnt++;

		if(tempCnt == 2)
		{
			//NOTE that if this is done, channel will also be reset to 0 - maybe add channel
			// to this call so it can also be reset if the following is done
			if(fAllowPrintf) if(bDBG)printf("syscal failed - doing firmware reset, then send signon\n\n");
			//NOTE: only if rate fails since there is a 2-second delay required after 
			resetDevFirmware(usDevID);
			sendSignonToken(usDevID);
			//LOOK			
			//put channel back, changed by syscal? Will cause two-channel changes if send-rate
			// is called by signon, but needed when not called from signon - decide how to handle
			//sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);

			continue;
		}

		if(tempCnt > 2) break;

	}
	if(!iSuccess)
	{
		if(fAllowPrintf) if(bDBG)printf("syscal failed - incorrect values returned - returning FALSE\n\n");
		return 0;
	}
	*dblRate_ = dblDevRate;
	if(fAllowPrintf)if(bDBG)printf("exiting sendRate - SUCCESS\n");		
	return TRUE;
}

//#############################################################################################################
//## SENDCHAN #################################################################################################
//#############################################################################################################
BYTE sendChan(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, BYTE bDBG, int* iErr)
{
	str_tx[0]=0x4;			//channel token
	str_tx[1]=bChan;		//channel
	str_tx[2]=bChan + 0x4;	//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
		//printf("channel change success.\n\n"); 
	}
	else 
	{  
		if(fAllowPrintf) printf("Error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		//usleep(2000); //8-22-24 
		return 0; 
	}
	// too short? usleep(20000); //8-22-24	
	//usleep(100000); //8-22-24b
	usleep(200000); //8-22-24b

	return 1;
}

//#########################################################################################################
//## SETDIGOUT ############################################################################################
//#########################################################################################################
BYTE setDigout(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDigOutVal, BYTE bDBG, int* iErr)
{
	BYTE bDigoutToken = 0x2;
	//sleep(1);  //commented because can't sleep if called while scanning
	str_tx[0]=bDigoutToken;    //analog out token
	str_tx[1]=bDigOutVal;
	str_tx[2]=bDigoutToken + bDigOutVal;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		//if(bDBG)printf("send digital output token success.\n\n");
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG)printf("setDigou error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		return 0; 
	}
	//sleep(1);
	return 1;
}

//###################################################################################################################
//## SETDAC #########################################################################################################
//###################################################################################################################
BYTE setDAC(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDAC, double* dblVolts_, BYTE bDBG, int* iErr)
{
	double dblVoltsLocal = *dblVolts_;
	double dblCntsPerVolt = 16383 / 5;
	short sCount = (short)(dblCntsPerVolt * dblVoltsLocal);
	if(sCount > 0x3fff) sCount = 0x3fff;
	short sHighByte = (short)(sCount / 64);
	short sLowByte = ((sCount - (sHighByte * 64)) * 4) + bDAC;
	str_tx[0]=0x0a;    //analog out token
	str_tx[1]=(unsigned char)(sHighByte);
	str_tx[2]=(unsigned char)((0xa + sHighByte) % 256);
	str_tx[3]=(unsigned char)(sLowByte);
	str_tx[4]=(unsigned char)(sLowByte);
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		if(bDBG)printf("send analog-out token success.\n\n");
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG)printf("setDAC error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		return 0; 
	}
	//TIM LOOK - let app deal with it so as to
	// not have any delay-affect while scanning 
	// usleep(700000); //8-26-24 

	return 1;
}

//###################################################################################################################
//## DOSYSCAL #######################################################################################################
//###################################################################################################################
BYTE doSyscal(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDBG, int* iErr)
{
	BYTE bCurChan = bSingleChanScanChan;

	str_tx[0]=CMD_SYSCAL;
	str_tx[1]=0;
	str_tx[2]=0 + (unsigned char)CMD_SYSCAL;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		if(fAllowPrintf) if(bDBG)printf("syscal success.\n\n");
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG)printf("doSyscal error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		return 0; 
	}

	//put channel back, changed by syscal
	sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);
	usleep(3000); //8-22-24 
	return 1;
}

//###################################################################################################################
//## DOFULLSCALECAL #################################################################################################
//###################################################################################################################
BYTE doFullscaleCal(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDBG, int* iErr)
{
	BYTE bCurChan = bSingleChanScanChan;

	str_tx[0]=CMD_FULLSCALE_CAL;
	str_tx[1]=0;
	str_tx[2]=0 + (unsigned char)CMD_FULLSCALE_CAL;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		if(fAllowPrintf) if(bDBG)printf("fullscale cal success.\n\n");
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG)printf("doFullScaleCal error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		return 0; 
	}

	//put channel back, changed by syscal
	sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);
	usleep(2000); 
	return 1;
}

//###################################################################################################################
//## DOFULLSCALECAL #################################################################################################
//###################################################################################################################
BYTE doOffsetCal(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDBG, int* iErr)
{
	BYTE bCurChan = bSingleChanScanChan;

	str_tx[0]=CMD_OFFSET_CAL;
	str_tx[1]=0;
	str_tx[2]=0 + (unsigned char)CMD_OFFSET_CAL;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		if(fAllowPrintf) if(bDBG)printf("offset cal success.\n\n");
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG)printf("doOffsetCal error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		return 0; 
	}
	usleep(3000); 
	//put channel back, changed by syscal
	sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);
	usleep(1000);
	return 1;
}

//#####################################################################
//## GETCONVERSION ####################################################
//#####################################################################
BYTE getConversion(struct libusb_device_handle *hDevice, USHORT usDevID, 
		double* dblVolts_, BYTE* bLastDigin, BYTE bDBG, int* iErr)
{
	double dblVolts;
	dataOut = (unsigned char *)malloc(32);  
	memset(dataOut,'\0',32);  
	int len=8;  
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) 
	{
		if(fAllowPrintf) if(bDBG) printf("transfer return code: %d in io\n", iRetCode);
	}
	if(iRetCode==0)
	{
		if(fAllowPrintf) if(bDBG) printf("send get-conv token success.\n\n");
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG) printf("getConversion error %d in bulk transfer\n", iRetCode); 
		*iErr = iRetCode;
		return 0; 
	}

	//read getconversion
	usleep(2000); //8-22-24 
	memset(dataOut,'\0',32);
	len = 32; //3-13-17
	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,5000);
	if(iRetCode==0)
	{
		usleep(2000); 
		if(fAllowPrintf) if(bDBG) 
		{
			system ("clear");
			printf("success reading conversion:\n");
			printf("dataOut[0]: %d \n", dataOut[0]);
			printf("dataOut[24]: %d \n", dataOut[24]);
			printf("dataOut[25]: %d \n", dataOut[25]);
			printf("dataOut[26]: %d\n", dataOut[26]);	//if 255 then power disconnected
			printf("dataOut[27]: %d\n", dataOut[27]);
			printf("dataOut[28]: %d\n", dataOut[28]);  
			printf("dataOut[29]: %d\n", dataOut[29]);
			printf("dataOut[30]: %d\n", dataOut[30]);
			printf("dataOut[31]: %d\n\n", dataOut[31]);
		}

		int iRawCnt = dataOut[28] + (dataOut[29] * 256) + (dataOut[30] * 65536);
		double dblVolts = (iRawCnt - 8388608) * 0.00000059604645;
		if(fAllowPrintf) if(bDBG) printf("volts: %lf\n\n", dblVolts);
		*bLastDigin = dataOut[0] & 0xf;  //5-4-17
		*dblVolts_ = dblVolts;
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG) printf("getConversoin error in bulk transfer\n"); 
		*iErr = iRetCode;
		return 0; 
	}
	return 1;
}

//#####################################################################
//## getDigitalInput ##################################################
//#####################################################################
//same as getting a conversion since it's returned in buffer[0] from
// firmware - just quiter - no screen output of conversion which comes
// witth it.
BYTE getDigitalInput(struct libusb_device_handle *hDevice, USHORT usDevID, 
		BYTE* bLastDigin, BYTE bDBG, int* iErr)
{
	double dblVolts;
	dataOut = (unsigned char *)malloc(32);  
	memset(dataOut,'\0',32);  
	int len=8;  
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) 
	{ 
		if(fAllowPrintf) if(bDBG) printf("transfer return code: %d in io\n", iRetCode); 
	}
	if(iRetCode==0)
	{ }
	else 
	{  
		*iErr = iRetCode;
		return 0; 
	}

	//read getconversion
	usleep(500); 
	memset(dataOut,'\0',32);
	len = 32; 
	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,5000);
	//    printf("Error number :: %d\n",iRetCode);
	//if(iRetCode==-1) printf("Error in io\n");
	if(iRetCode==0)
	{
		*bLastDigin = dataOut[0] & 0xf;  
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG) printf("getDigitalInput - error in bulk transfer\n"); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		return 0; 
	}
	return 1;
}



//######################################################################################################
//######################################################################################################
//######################################################################################################
//## RESETSIMPLE #######################################################################################
//######################################################################################################
BYTE resetSimple(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, BYTE bDBG, int* iErr)
{
	str_tx[0]=0x1;    //reset token
	str_tx[1]=0x0;    //no arg
	str_tx[2]=0x1;    //checksum
	int len = 8;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
		if(fAllowPrintf) printf("simple reset success.\n\n"); 
	}
	else 
	{  
		if(fAllowPrintf) printf("resetSimple error %d in bulk transfer during a reset\n", iRetCode); 
		*iErr = iRetCode;
		//8-22-24 sleep(3);
		return 0; 
	}
	return 1;
}


//#####################################################################################################################
//#####################################################################################################################
//#####################################################################################################################
//## SENDSIGNON 6-5-17 ################################################################################################
//#####################################################################################################################
BYTE sendSignon(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, double* dblRate, BYTE bDBG, int* iErr)
{
//fAllowPrintf = TRUE; 
//bDBG = 1;
	struct  libusb_endpoint_descriptor *ep;
	struct  libusb_interface_descriptor *id;
	int len=64,ret_alt,ret_clm,ret_rst;
	struct libusb_device **list;
	dataOut = (unsigned char *)malloc(32);
	memset(dataOut,'\0',32);

	str_tx[0]=0x0;    			//token
	str_tx[0]=0x0;    			//arg
	str_tx[0]=0x0;    			//checksum
	unsigned char str_rx[32];	//receive string
	
	ret_rst = libusb_reset_device(hDevice);
	if(ret_rst < 0) 
	{ 
		if(fAllowPrintf) if(bDBG) printf("Error in reset: %d \n", ret_rst); 
		*iErr = iRetCode;
		if(fAllowPrintf) if(bDBG)printf("exiting signon - FAILED\n");
		return 0; 
	}
	
	//SEND SIGNON
  if(fAllowPrintf) if(bDBG) printf("sending signon token\n");
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
		if(fAllowPrintf) if(bDBG) printf("signon token-send success\n\n"); 
	}
	else 
	{ 
    if(fAllowPrintf) if(bDBG) printf("error %d sending signon token \n", iRetCode);
		*iErr = iRetCode;
		if(fAllowPrintf) if(bDBG)printf("exiting signon - FAILED\n");
		return 0; 
	}

	memset(dataOut,'\0',32);
	int tempCnt = 0;
	if(fAllowPrintf) if(bDBG)printf("reading signon return vals\n");	
	while(1==1)
	{
		usleep(4000); 
		
		iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,32);
		if(fAllowPrintf) if(bDBG) printf("iRetCode %u, iLenOut: %u\n", iRetCode, iLenOut);
		if((iRetCode == 0) && (iLenOut == 32)) break;		
	
		if(((dataOut[26] & 0xfe) == 0x2) && (dataOut[27] == 0x23) && (dataOut[29] == 0x8c))
		{
			if(fAllowPrintf) if(bDBG) printf("got correct signon return vals\n");
			break;
		}
		tempCnt++;
		if(fAllowPrintf) if(bDBG) printf("tempCnt: %u\n", tempCnt);			
 		if(tempCnt > 1) break;
	}
	if((iRetCode==0) &&(iLenOut == 32))
	{
		if(fAllowPrintf) if(bDBG)
		{
			printf("signon results:\n");
			printf("dataOut[26]: 0x%x\n", dataOut[26] & 0xfe);
			printf("dataOut[27]: 0x%x\n", dataOut[27]);
			printf("dataOut[28]: 0x%x\n", dataOut[28]);
			printf("dataOut[29]: 0x%x\n", dataOut[29]);
			printf("dataOut[30]: 0x%x\n", dataOut[30]);
			printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
			printf("NOTE: may be all zeoes after first signon?\n");
		}
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG) printf("sendSignon error %d reading signon return values\n", iRetCode);
		*iErr = iRetCode;
		if(fAllowPrintf) if(bDBG) printf("exiting signon - FAILED\n");
		return FALSE; 
	}

	//GET ACTUAL RATE BOARD CAN DO
	//BYTE calcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dlbDevRate)
	if(fAllowPrintf) if(bDBG)printf("send signon getting rate codes\n");
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dlbDevRate = *dblRate;
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dlbDevRate);
	if(fAllowPrintf) if(bDBG) printf("got bLow: %d, bMid: %d, bHigh: %d\n", bLow_, bMid_, bHigh_);

	//SEND RATE
	if(dlbDevRate != *dblRate)
	{
		if(fAllowPrintf) if(bDBG) printf("sending rate (requested was: %lf, adjusted: %lf\n", *dblRate, dlbDevRate);
	}
	else
	{
		if(fAllowPrintf) if(bDBG) printf("sending rate %lf\n", dlbDevRate);
	}

	int bLow, bMid, bHigh;		

	bLow = bLow_;
	bMid = bMid_;
	bHigh = bHigh_;

	str_tx[0]=0x84;		//rate token
	str_tx[1]=bLow; 	
	str_tx[2]=bMid; 	
	str_tx[3]=bHigh;	
	str_tx[4]=0x22;	
	
	if(fAllowPrintf) if(bDBG) printf("sendSignon sending rate codes\n");
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,8);
	
	if((iRetCode==0) && (iLenIn==8))
	{ 
		if(fAllowPrintf) if(bDBG) printf("rate send success.\n"); 
	}
	else 
	{  
		if(fAllowPrintf) if(bDBG) printf("sendSignon error %d sending rate\n", iRetCode);
		*iErr = iRetCode;
		if(fAllowPrintf) if(bDBG) printf("exiting signon - FAILED\n");
		return 0; 
	}

	//read rate result
	int iSuccess = 0;
	if(fAllowPrintf) if(bDBG) printf("checking rate send return vals.\n"); 
	while(1==1)
	{
		usleep(2000); //8-22-24 
		// fails if set to 32, which is all that's needed?
		iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,4000);
		if(fAllowPrintf) if(bDBG) printf("got iRetCode: %i, iLenOut: %u \n", iRetCode, iLenOut);
		if((dataOut[24] == 0x1) && (dataOut[25] == 0x2) && (dataOut[26] == 0x3)
		&& ((dataOut[27] & 0xfe) == 0x22) && (dataOut[28] == bHigh) && (dataOut[29] == bMid)
		&& (dataOut[30] == bLow))
		{
			if(fAllowPrintf) if(bDBG)
			{
				printf("got correct syscal return vals\n");
				printf("dataOut[24]: 0x%x\n", dataOut[24]);
				printf("dataOut[25]: 0x%x\n", dataOut[25]);
				printf("dataOut[26]: 0x%x\n", dataOut[26]);
				printf("dataOut[27]: 0x%x\n", dataOut[27] & 0xfe);
				printf("dataOut[28]: 0x%x\n", dataOut[28]);
				printf("dataOut[29]: 0x%x\n", dataOut[29]);
				printf("dataOut[30]: 0x%x\n", dataOut[30]);
				printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
			}
			iSuccess = 1;
			break;
		}
		if(fAllowPrintf) if(bDBG) printf("sendSignon wrong return rate codes\n");
		if(fAllowPrintf) if(bDBG) printf("may need reset and start signon again\n");
		tempCnt++;
		if(fAllowPrintf) if(bDBG) printf("tempCnt: %u\n", tempCnt);			
		if(fAllowPrintf) if(bDBG) printf("iRetCode: %d, iLenIn: %u\n",iRetCode, iLenIn );
		if(tempCnt > 2) break;
	}
	if(!iSuccess)
	{
		if(fAllowPrintf) if(bDBG) printf("sendSignon - syscal failed - incorrect values returned\n\n");
		if(fAllowPrintf) if(bDBG) printf("exiting signon - FAILED\n");
		return FALSE;
	}

	//send channel
	BOOLEAN fChanChngSuccess = FALSE;
	for(int i=0; i<4; i++)	
	{
		bChan = 0; 
		if(fAllowPrintf) if(bDBG) printf("sendSignon - sending channel: %d\n", bChan);
		str_tx[0]=0x4;		//setChan token
		str_tx[1]=bChan;	//channel val
		str_tx[2]=0x4;		//checksum
		iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
		if(fAllowPrintf) if(bDBG) printf("from signon chan-change - iRetCode: %d, iLenIn: %u\n",iRetCode, iLenIn );
		if((iRetCode==0) && (iLenIn == 8)) 
		{ 
			if(fAllowPrintf) if(bDBG) printf("sendSignon - channel change success.\n\n"); 
			fChanChngSuccess = TRUE;		
			break;		
		}
		else 
		{  
			if(fAllowPrintf) if(bDBG) printf("sendSignon - error %d sending channel\n", iRetCode);
			*iErr = iRetCode;
			return FALSE; 
		}
	}
	if(fAllowPrintf) if(bDBG)printf("exiting signon\n");
	if(!fChanChngSuccess) return FALSE;
	return 1;
}

//seems libusb always does this as seems to be indicated in the libusb docs?
//#################
//## CLOSEDEV #####
//#################
BYTE closeDev(void)
{
	libusb_close(hDevice_global);
	return 1;
}

